git-am.shon commit am --abort: support aborting to unborn branch (e06764c)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_STUCKLONG=t
   8OPTIONS_SPEC="\
   9git am [options] [(<mbox>|<Maildir>)...]
  10git am [options] (--continue | --skip | --abort)
  11--
  12i,interactive   run interactively
  13b,binary*       (historical option -- no-op)
  143,3way          allow fall back on 3way merging if needed
  15q,quiet         be quiet
  16s,signoff       add a Signed-off-by line to the commit message
  17u,utf8          recode into utf8 (default)
  18k,keep          pass -k flag to git-mailinfo
  19keep-non-patch  pass -b flag to git-mailinfo
  20keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  21no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  22c,scissors      strip everything before a scissors line
  23whitespace=     pass it through git-apply
  24ignore-space-change pass it through git-apply
  25ignore-whitespace pass it through git-apply
  26directory=      pass it through git-apply
  27exclude=        pass it through git-apply
  28include=        pass it through git-apply
  29C=              pass it through git-apply
  30p=              pass it through git-apply
  31patch-format=   format the patch(es) are in
  32reject          pass it through git-apply
  33resolvemsg=     override error message when patch failure occurs
  34continue        continue applying patches after resolving a conflict
  35r,resolved      synonyms for --continue
  36skip            skip the current patch
  37abort           restore the original branch and abort the patching operation.
  38committer-date-is-author-date    lie about committer date
  39ignore-date     use current timestamp for author date
  40rerere-autoupdate update the index with reused conflict resolution if possible
  41S,gpg-sign?     GPG-sign commits
  42rebasing*       (internal use for git-rebase)"
  43
  44. git-sh-setup
  45. git-sh-i18n
  46prefix=$(git rev-parse --show-prefix)
  47set_reflog_action am
  48require_work_tree
  49cd_to_toplevel
  50
  51git var GIT_COMMITTER_IDENT >/dev/null ||
  52        die "$(gettext "You need to set your committer info first")"
  53
  54if git rev-parse --verify -q HEAD >/dev/null
  55then
  56        HAS_HEAD=yes
  57else
  58        HAS_HEAD=
  59fi
  60
  61cmdline="git am"
  62if test '' != "$interactive"
  63then
  64        cmdline="$cmdline -i"
  65fi
  66if test '' != "$threeway"
  67then
  68        cmdline="$cmdline -3"
  69fi
  70
  71empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
  72
  73sq () {
  74        git rev-parse --sq-quote "$@"
  75}
  76
  77stop_here () {
  78    echo "$1" >"$dotest/next"
  79    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  80    exit 1
  81}
  82
  83safe_to_abort () {
  84        if test -f "$dotest/dirtyindex"
  85        then
  86                return 1
  87        fi
  88
  89        if ! test -s "$dotest/abort-safety"
  90        then
  91                return 0
  92        fi
  93
  94        abort_safety=$(cat "$dotest/abort-safety")
  95        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  96        then
  97                return 0
  98        fi
  99        gettextln "You seem to have moved HEAD since the last 'am' failure.
 100Not rewinding to ORIG_HEAD" >&2
 101        return 1
 102}
 103
 104stop_here_user_resolve () {
 105    if [ -n "$resolvemsg" ]; then
 106            printf '%s\n' "$resolvemsg"
 107            stop_here $1
 108    fi
 109    eval_gettextln "When you have resolved this problem, run \"\$cmdline --continue\".
 110If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
 111To restore the original branch and stop patching, run \"\$cmdline --abort\"."
 112
 113    stop_here $1
 114}
 115
 116go_next () {
 117        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 118                "$dotest/patch" "$dotest/info"
 119        echo "$next" >"$dotest/next"
 120        this=$next
 121}
 122
 123cannot_fallback () {
 124        echo "$1"
 125        gettextln "Cannot fall back to three-way merge."
 126        exit 1
 127}
 128
 129fall_back_3way () {
 130    O_OBJECT=$(cd "$GIT_OBJECT_DIRECTORY" && pwd)
 131
 132    rm -fr "$dotest"/patch-merge-*
 133    mkdir "$dotest/patch-merge-tmp-dir"
 134
 135    # First see if the patch records the index info that we can use.
 136    cmd="git apply $git_apply_opt --build-fake-ancestor" &&
 137    cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
 138    eval "$cmd" &&
 139    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 140    git write-tree >"$dotest/patch-merge-base+" ||
 141    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 142
 143    say "$(gettext "Using index info to reconstruct a base tree...")"
 144
 145    cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
 146
 147    if test -z "$GIT_QUIET"
 148    then
 149        eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
 150    fi
 151
 152    cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
 153    if eval "$cmd"
 154    then
 155        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 156        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 157    else
 158        cannot_fallback "$(gettext "Did you hand edit your patch?
 159It does not apply to blobs recorded in its index.")"
 160    fi
 161
 162    test -f "$dotest/patch-merge-index" &&
 163    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 164    orig_tree=$(cat "$dotest/patch-merge-base") &&
 165    rm -fr "$dotest"/patch-merge-* || exit 1
 166
 167    say "$(gettext "Falling back to patching base and 3-way merge...")"
 168
 169    # This is not so wrong.  Depending on which base we picked,
 170    # orig_tree may be wildly different from ours, but his_tree
 171    # has the same set of wildly different changes in parts the
 172    # patch did not touch, so recursive ends up canceling them,
 173    # saying that we reverted all those changes.
 174
 175    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 176    export GITHEAD_$his_tree
 177    if test -n "$GIT_QUIET"
 178    then
 179            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 180    fi
 181    our_tree=$(git rev-parse --verify -q HEAD || echo $empty_tree)
 182    git-merge-recursive $orig_tree -- $our_tree $his_tree || {
 183            git rerere $allow_rerere_autoupdate
 184            die "$(gettext "Failed to merge in the changes.")"
 185    }
 186    unset GITHEAD_$his_tree
 187}
 188
 189clean_abort () {
 190        test $# = 0 || echo >&2 "$@"
 191        rm -fr "$dotest"
 192        exit 1
 193}
 194
 195patch_format=
 196
 197check_patch_format () {
 198        # early return if patch_format was set from the command line
 199        if test -n "$patch_format"
 200        then
 201                return 0
 202        fi
 203
 204        # we default to mbox format if input is from stdin and for
 205        # directories
 206        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 207        then
 208                patch_format=mbox
 209                return 0
 210        fi
 211
 212        # otherwise, check the first few non-blank lines of the first
 213        # patch to try to detect its format
 214        {
 215                # Start from first line containing non-whitespace
 216                l1=
 217                while test -z "$l1"
 218                do
 219                        read l1 || break
 220                done
 221                read l2
 222                read l3
 223                case "$l1" in
 224                "From "* | "From: "*)
 225                        patch_format=mbox
 226                        ;;
 227                '# This series applies on GIT commit'*)
 228                        patch_format=stgit-series
 229                        ;;
 230                "# HG changeset patch")
 231                        patch_format=hg
 232                        ;;
 233                *)
 234                        # if the second line is empty and the third is
 235                        # a From, Author or Date entry, this is very
 236                        # likely an StGIT patch
 237                        case "$l2,$l3" in
 238                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 239                                patch_format=stgit
 240                                ;;
 241                        *)
 242                                ;;
 243                        esac
 244                        ;;
 245                esac
 246                if test -z "$patch_format" &&
 247                        test -n "$l1" &&
 248                        test -n "$l2" &&
 249                        test -n "$l3"
 250                then
 251                        # This begins with three non-empty lines.  Is this a
 252                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 253                        # discarding the indented remainder of folded lines,
 254                        # and see if it looks like that they all begin with the
 255                        # header field names...
 256                        tr -d '\015' <"$1" |
 257                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 258                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 259                        patch_format=mbox
 260                fi
 261        } < "$1" || clean_abort
 262}
 263
 264split_patches () {
 265        case "$patch_format" in
 266        mbox)
 267                if test t = "$keepcr"
 268                then
 269                    keep_cr=--keep-cr
 270                else
 271                    keep_cr=
 272                fi
 273                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 274                clean_abort
 275                ;;
 276        stgit-series)
 277                if test $# -ne 1
 278                then
 279                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 280                fi
 281                series_dir=$(dirname "$1")
 282                series_file="$1"
 283                shift
 284                {
 285                        set x
 286                        while read filename
 287                        do
 288                                set "$@" "$series_dir/$filename"
 289                        done
 290                        # remove the safety x
 291                        shift
 292                        # remove the arg coming from the first-line comment
 293                        shift
 294                } < "$series_file" || clean_abort
 295                # set the patch format appropriately
 296                patch_format=stgit
 297                # now handle the actual StGIT patches
 298                split_patches "$@"
 299                ;;
 300        stgit)
 301                this=0
 302                for stgit in "$@"
 303                do
 304                        this=$(expr "$this" + 1)
 305                        msgnum=$(printf "%0${prec}d" $this)
 306                        # Perl version of StGIT parse_patch. The first nonemptyline
 307                        # not starting with Author, From or Date is the
 308                        # subject, and the body starts with the next nonempty
 309                        # line not starting with Author, From or Date
 310                        @@PERL@@ -ne 'BEGIN { $subject = 0 }
 311                                if ($subject > 1) { print ; }
 312                                elsif (/^\s+$/) { next ; }
 313                                elsif (/^Author:/) { s/Author/From/ ; print ;}
 314                                elsif (/^(From|Date)/) { print ; }
 315                                elsif ($subject) {
 316                                        $subject = 2 ;
 317                                        print "\n" ;
 318                                        print ;
 319                                } else {
 320                                        print "Subject: ", $_ ;
 321                                        $subject = 1;
 322                                }
 323                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 324                done
 325                echo "$this" > "$dotest/last"
 326                this=
 327                msgnum=
 328                ;;
 329        hg)
 330                this=0
 331                for hg in "$@"
 332                do
 333                        this=$(( $this + 1 ))
 334                        msgnum=$(printf "%0${prec}d" $this)
 335                        # hg stores changeset metadata in #-commented lines preceding
 336                        # the commit message and diff(s). The only metadata we care about
 337                        # are the User and Date (Node ID and Parent are hashes which are
 338                        # only relevant to the hg repository and thus not useful to us)
 339                        # Since we cannot guarantee that the commit message is in
 340                        # git-friendly format, we put no Subject: line and just consume
 341                        # all of the message as the body
 342                        LANG=C LC_ALL=C @@PERL@@ -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
 343                                if ($subject) { print ; }
 344                                elsif (/^\# User /) { s/\# User/From:/ ; print ; }
 345                                elsif (/^\# Date /) {
 346                                        my ($hashsign, $str, $time, $tz) = split ;
 347                                        $tz = sprintf "%+05d", (0-$tz)/36;
 348                                        print "Date: " .
 349                                              strftime("%a, %d %b %Y %H:%M:%S ",
 350                                                       localtime($time))
 351                                              . "$tz\n";
 352                                } elsif (/^\# /) { next ; }
 353                                else {
 354                                        print "\n", $_ ;
 355                                        $subject = 1;
 356                                }
 357                        ' <"$hg" >"$dotest/$msgnum" || clean_abort
 358                done
 359                echo "$this" >"$dotest/last"
 360                this=
 361                msgnum=
 362                ;;
 363        *)
 364                if test -n "$patch_format"
 365                then
 366                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 367                else
 368                        clean_abort "$(gettext "Patch format detection failed.")"
 369                fi
 370                ;;
 371        esac
 372}
 373
 374prec=4
 375dotest="$GIT_DIR/rebase-apply"
 376sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 377resolvemsg= resume= scissors= no_inbody_headers=
 378git_apply_opt=
 379committer_date_is_author_date=
 380ignore_date=
 381allow_rerere_autoupdate=
 382gpg_sign_opt=
 383
 384if test "$(git config --bool --get am.keepcr)" = true
 385then
 386    keepcr=t
 387fi
 388
 389while test $# != 0
 390do
 391        case "$1" in
 392        -i|--interactive)
 393                interactive=t ;;
 394        -b|--binary)
 395                gettextln >&2 "The -b/--binary option has been a no-op for long time, and
 396it will be removed. Please do not use it anymore."
 397                ;;
 398        -3|--3way)
 399                threeway=t ;;
 400        -s|--signoff)
 401                sign=t ;;
 402        -u|--utf8)
 403                utf8=t ;; # this is now default
 404        --no-utf8)
 405                utf8= ;;
 406        -k|--keep)
 407                keep=t ;;
 408        --keep-non-patch)
 409                keep=b ;;
 410        -c|--scissors)
 411                scissors=t ;;
 412        --no-scissors)
 413                scissors=f ;;
 414        -r|--resolved|--continue)
 415                resolved=t ;;
 416        --skip)
 417                skip=t ;;
 418        --abort)
 419                abort=t ;;
 420        --rebasing)
 421                rebasing=t threeway=t ;;
 422        --resolvemsg=*)
 423                resolvemsg="${1#--resolvemsg=}" ;;
 424        --whitespace=*|--directory=*|--exclude=*|--include=*)
 425                git_apply_opt="$git_apply_opt $(sq "$1")" ;;
 426        -C*|-p*)
 427                git_apply_opt="$git_apply_opt $(sq "$1")" ;;
 428        --patch-format=*)
 429                patch_format="${1#--patch-format=}" ;;
 430        --reject|--ignore-whitespace|--ignore-space-change)
 431                git_apply_opt="$git_apply_opt $1" ;;
 432        --committer-date-is-author-date)
 433                committer_date_is_author_date=t ;;
 434        --ignore-date)
 435                ignore_date=t ;;
 436        --rerere-autoupdate|--no-rerere-autoupdate)
 437                allow_rerere_autoupdate="$1" ;;
 438        -q|--quiet)
 439                GIT_QUIET=t ;;
 440        --keep-cr)
 441                keepcr=t ;;
 442        --no-keep-cr)
 443                keepcr=f ;;
 444        --gpg-sign)
 445                gpg_sign_opt=-S ;;
 446        --gpg-sign=*)
 447                gpg_sign_opt="-S${1#--gpg-sign=}" ;;
 448        --)
 449                shift; break ;;
 450        *)
 451                usage ;;
 452        esac
 453        shift
 454done
 455
 456# If the dotest directory exists, but we have finished applying all the
 457# patches in them, clear it out.
 458if test -d "$dotest" &&
 459   test -f "$dotest/last" &&
 460   test -f "$dotest/next" &&
 461   last=$(cat "$dotest/last") &&
 462   next=$(cat "$dotest/next") &&
 463   test $# != 0 &&
 464   test "$next" -gt "$last"
 465then
 466   rm -fr "$dotest"
 467fi
 468
 469if test -d "$dotest" && test -f "$dotest/last" && test -f "$dotest/next"
 470then
 471        case "$#,$skip$resolved$abort" in
 472        0,*t*)
 473                # Explicit resume command and we do not have file, so
 474                # we are happy.
 475                : ;;
 476        0,)
 477                # No file input but without resume parameters; catch
 478                # user error to feed us a patch from standard input
 479                # when there is already $dotest.  This is somewhat
 480                # unreliable -- stdin could be /dev/null for example
 481                # and the caller did not intend to feed us a patch but
 482                # wanted to continue unattended.
 483                test -t 0
 484                ;;
 485        *)
 486                false
 487                ;;
 488        esac ||
 489        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 490        resume=yes
 491
 492        case "$skip,$abort" in
 493        t,t)
 494                die "$(gettext "Please make up your mind. --skip or --abort?")"
 495                ;;
 496        t,)
 497                git rerere clear
 498                head_tree=$(git rev-parse --verify -q HEAD || echo $empty_tree) &&
 499                git read-tree --reset -u $head_tree $head_tree &&
 500                index_tree=$(git write-tree) &&
 501                git read-tree -m -u $index_tree $head_tree
 502                git read-tree $head_tree
 503                ;;
 504        ,t)
 505                if test -f "$dotest/rebasing"
 506                then
 507                        exec git rebase --abort
 508                fi
 509                git rerere clear
 510                if safe_to_abort
 511                then
 512                        head_tree=$(git rev-parse --verify -q HEAD || echo $empty_tree) &&
 513                        git read-tree --reset -u $head_tree $head_tree &&
 514                        index_tree=$(git write-tree) &&
 515                        orig_head=$(git rev-parse --verify -q ORIG_HEAD || echo $empty_tree) &&
 516                        git read-tree -m -u $index_tree $orig_head
 517                        if git rev-parse --verify -q ORIG_HEAD >/dev/null 2>&1
 518                        then
 519                                git reset ORIG_HEAD
 520                        else
 521                                git read-tree $empty_tree
 522                                curr_branch=$(git symbolic-ref HEAD 2>/dev/null) &&
 523                                git update-ref -d $curr_branch
 524                        fi
 525                fi
 526                rm -fr "$dotest"
 527                exit ;;
 528        esac
 529        rm -f "$dotest/dirtyindex"
 530else
 531        # Possible stray $dotest directory in the independent-run
 532        # case; in the --rebasing case, it is upto the caller
 533        # (git-rebase--am) to take care of stray directories.
 534        if test -d "$dotest" && test -z "$rebasing"
 535        then
 536                case "$skip,$resolved,$abort" in
 537                ,,t)
 538                        rm -fr "$dotest"
 539                        exit 0
 540                        ;;
 541                *)
 542                        die "$(eval_gettext "Stray \$dotest directory found.
 543Use \"git am --abort\" to remove it.")"
 544                        ;;
 545                esac
 546        fi
 547
 548        # Make sure we are not given --skip, --continue, or --abort
 549        test "$skip$resolved$abort" = "" ||
 550                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 551
 552        # Start afresh.
 553        mkdir -p "$dotest" || exit
 554
 555        if test -n "$prefix" && test $# != 0
 556        then
 557                first=t
 558                for arg
 559                do
 560                        test -n "$first" && {
 561                                set x
 562                                first=
 563                        }
 564                        if is_absolute_path "$arg"
 565                        then
 566                                set "$@" "$arg"
 567                        else
 568                                set "$@" "$prefix$arg"
 569                        fi
 570                done
 571                shift
 572        fi
 573
 574        check_patch_format "$@"
 575
 576        split_patches "$@"
 577
 578        # -i can and must be given when resuming; everything
 579        # else is kept
 580        echo " $git_apply_opt" >"$dotest/apply-opt"
 581        echo "$threeway" >"$dotest/threeway"
 582        echo "$sign" >"$dotest/sign"
 583        echo "$utf8" >"$dotest/utf8"
 584        echo "$keep" >"$dotest/keep"
 585        echo "$scissors" >"$dotest/scissors"
 586        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 587        echo "$GIT_QUIET" >"$dotest/quiet"
 588        echo 1 >"$dotest/next"
 589        if test -n "$rebasing"
 590        then
 591                : >"$dotest/rebasing"
 592        else
 593                : >"$dotest/applying"
 594                if test -n "$HAS_HEAD"
 595                then
 596                        git update-ref ORIG_HEAD HEAD
 597                else
 598                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 599                fi
 600        fi
 601fi
 602
 603git update-index -q --refresh
 604
 605case "$resolved" in
 606'')
 607        case "$HAS_HEAD" in
 608        '')
 609                files=$(git ls-files) ;;
 610        ?*)
 611                files=$(git diff-index --cached --name-only HEAD --) ;;
 612        esac || exit
 613        if test "$files"
 614        then
 615                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 616                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 617        fi
 618esac
 619
 620# Now, decide what command line options we will give to the git
 621# commands we invoke, based on the result of parsing command line
 622# options and previous invocation state stored in $dotest/ files.
 623
 624if test "$(cat "$dotest/utf8")" = t
 625then
 626        utf8=-u
 627else
 628        utf8=-n
 629fi
 630keep=$(cat "$dotest/keep")
 631case "$keep" in
 632t)
 633        keep=-k ;;
 634b)
 635        keep=-b ;;
 636*)
 637        keep= ;;
 638esac
 639case "$(cat "$dotest/scissors")" in
 640t)
 641        scissors=--scissors ;;
 642f)
 643        scissors=--no-scissors ;;
 644esac
 645if test "$(cat "$dotest/no_inbody_headers")" = t
 646then
 647        no_inbody_headers=--no-inbody-headers
 648else
 649        no_inbody_headers=
 650fi
 651if test "$(cat "$dotest/quiet")" = t
 652then
 653        GIT_QUIET=t
 654fi
 655if test "$(cat "$dotest/threeway")" = t
 656then
 657        threeway=t
 658fi
 659git_apply_opt=$(cat "$dotest/apply-opt")
 660if test "$(cat "$dotest/sign")" = t
 661then
 662        SIGNOFF=$(git var GIT_COMMITTER_IDENT | sed -e '
 663                        s/>.*/>/
 664                        s/^/Signed-off-by: /'
 665                )
 666else
 667        SIGNOFF=
 668fi
 669
 670last=$(cat "$dotest/last")
 671this=$(cat "$dotest/next")
 672if test "$skip" = t
 673then
 674        this=$(expr "$this" + 1)
 675        resume=
 676fi
 677
 678while test "$this" -le "$last"
 679do
 680        msgnum=$(printf "%0${prec}d" $this)
 681        next=$(expr "$this" + 1)
 682        test -f "$dotest/$msgnum" || {
 683                resume=
 684                go_next
 685                continue
 686        }
 687
 688        # If we are not resuming, parse and extract the patch information
 689        # into separate files:
 690        #  - info records the authorship and title
 691        #  - msg is the rest of commit log message
 692        #  - patch is the patch body.
 693        #
 694        # When we are resuming, these files are either already prepared
 695        # by the user, or the user can tell us to do so by --continue flag.
 696        case "$resume" in
 697        '')
 698                if test -f "$dotest/rebasing"
 699                then
 700                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 701                                -e q "$dotest/$msgnum") &&
 702                        test "$(git cat-file -t "$commit")" = commit ||
 703                                stop_here $this
 704                        git cat-file commit "$commit" |
 705                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 706                        echo "$commit" >"$dotest/original-commit"
 707                        get_author_ident_from_commit "$commit" >"$dotest/author-script"
 708                        git diff-tree --root --binary --full-index "$commit" >"$dotest/patch"
 709                else
 710                        git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 711                                <"$dotest/$msgnum" >"$dotest/info" ||
 712                                stop_here $this
 713
 714                        # skip pine's internal folder data
 715                        sane_grep '^Author: Mail System Internal Data$' \
 716                                <"$dotest"/info >/dev/null &&
 717                                go_next && continue
 718
 719                        test -s "$dotest/patch" || {
 720                                eval_gettextln "Patch is empty.  Was it split wrong?
 721If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 722To restore the original branch and stop patching run \"\$cmdline --abort\"."
 723                                stop_here $this
 724                        }
 725                        rm -f "$dotest/original-commit" "$dotest/author-script"
 726                        {
 727                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 728                                echo
 729                                cat "$dotest/msg"
 730                        } |
 731                        git stripspace > "$dotest/msg-clean"
 732                fi
 733                ;;
 734        esac
 735
 736        if test -f "$dotest/author-script"
 737        then
 738                eval $(cat "$dotest/author-script")
 739        else
 740                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 741                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 742                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 743        fi
 744
 745        if test -z "$GIT_AUTHOR_EMAIL"
 746        then
 747                gettextln "Patch does not have a valid e-mail address."
 748                stop_here $this
 749        fi
 750
 751        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 752
 753        case "$resume" in
 754        '')
 755            if test '' != "$SIGNOFF"
 756            then
 757                LAST_SIGNED_OFF_BY=$(
 758                    sed -ne '/^Signed-off-by: /p' \
 759                    "$dotest/msg-clean" |
 760                    sed -ne '$p'
 761                )
 762                ADD_SIGNOFF=$(
 763                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 764                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 765                    echo "$SIGNOFF"
 766                })
 767            else
 768                ADD_SIGNOFF=
 769            fi
 770            {
 771                if test -s "$dotest/msg-clean"
 772                then
 773                        cat "$dotest/msg-clean"
 774                fi
 775                if test '' != "$ADD_SIGNOFF"
 776                then
 777                        echo "$ADD_SIGNOFF"
 778                fi
 779            } >"$dotest/final-commit"
 780            ;;
 781        *)
 782                case "$resolved$interactive" in
 783                tt)
 784                        # This is used only for interactive view option.
 785                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 786                        ;;
 787                esac
 788        esac
 789
 790        resume=
 791        if test "$interactive" = t
 792        then
 793            test -t 0 ||
 794            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 795            action=again
 796            while test "$action" = again
 797            do
 798                gettextln "Commit Body is:"
 799                echo "--------------------------"
 800                cat "$dotest/final-commit"
 801                echo "--------------------------"
 802                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 803                # in your translation. The program will only accept English
 804                # input at this point.
 805                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 806                read reply
 807                case "$reply" in
 808                [yY]*) action=yes ;;
 809                [aA]*) action=yes interactive= ;;
 810                [nN]*) action=skip ;;
 811                [eE]*) git_editor "$dotest/final-commit"
 812                       action=again ;;
 813                [vV]*) action=again
 814                       git_pager "$dotest/patch" ;;
 815                *)     action=again ;;
 816                esac
 817            done
 818        else
 819            action=yes
 820        fi
 821
 822        if test $action = skip
 823        then
 824                go_next
 825                continue
 826        fi
 827
 828        if test -x "$GIT_DIR"/hooks/applypatch-msg
 829        then
 830                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 831                stop_here $this
 832        fi
 833
 834        if test -f "$dotest/final-commit"
 835        then
 836                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 837        else
 838                FIRSTLINE=""
 839        fi
 840
 841        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 842
 843        case "$resolved" in
 844        '')
 845                # When we are allowed to fall back to 3-way later, don't give
 846                # false errors during the initial attempt.
 847                squelch=
 848                if test "$threeway" = t
 849                then
 850                        squelch='>/dev/null 2>&1 '
 851                fi
 852                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 853                apply_status=$?
 854                ;;
 855        t)
 856                # Resolved means the user did all the hard work, and
 857                # we do not have to do any patch application.  Just
 858                # trust what the user has in the index file and the
 859                # working tree.
 860                resolved=
 861                git diff-index --quiet --cached HEAD -- && {
 862                        gettextln "No changes - did you forget to use 'git add'?
 863If there is nothing left to stage, chances are that something else
 864already introduced the same changes; you might want to skip this patch."
 865                        stop_here_user_resolve $this
 866                }
 867                unmerged=$(git ls-files -u)
 868                if test -n "$unmerged"
 869                then
 870                        gettextln "You still have unmerged paths in your index
 871did you forget to use 'git add'?"
 872                        stop_here_user_resolve $this
 873                fi
 874                apply_status=0
 875                git rerere
 876                ;;
 877        esac
 878
 879        if test $apply_status != 0 && test "$threeway" = t
 880        then
 881                if (fall_back_3way)
 882                then
 883                    # Applying the patch to an earlier tree and merging the
 884                    # result may have produced the same tree as ours.
 885                    git diff-index --quiet --cached HEAD -- && {
 886                        say "$(gettext "No changes -- Patch already applied.")"
 887                        go_next
 888                        continue
 889                    }
 890                    # clear apply_status -- we have successfully merged.
 891                    apply_status=0
 892                fi
 893        fi
 894        if test $apply_status != 0
 895        then
 896                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 897                if test "$(git config --bool advice.amworkdir)" != false
 898                then
 899                        eval_gettextln 'The copy of the patch that failed is found in:
 900   $dotest/patch'
 901                fi
 902                stop_here_user_resolve $this
 903        fi
 904
 905        if test -x "$GIT_DIR"/hooks/pre-applypatch
 906        then
 907                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 908        fi
 909
 910        tree=$(git write-tree) &&
 911        commit=$(
 912                if test -n "$ignore_date"
 913                then
 914                        GIT_AUTHOR_DATE=
 915                fi
 916                parent=$(git rev-parse --verify -q HEAD) ||
 917                say >&2 "$(gettext "applying to an empty history")"
 918
 919                if test -n "$committer_date_is_author_date"
 920                then
 921                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 922                        export GIT_COMMITTER_DATE
 923                fi &&
 924                git commit-tree ${parent:+-p} $parent ${gpg_sign_opt:+"$gpg_sign_opt"} $tree  \
 925                        <"$dotest/final-commit"
 926        ) &&
 927        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 928        stop_here $this
 929
 930        if test -f "$dotest/original-commit"; then
 931                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 932        fi
 933
 934        if test -x "$GIT_DIR"/hooks/post-applypatch
 935        then
 936                "$GIT_DIR"/hooks/post-applypatch
 937        fi
 938
 939        go_next
 940done
 941
 942if test -s "$dotest"/rewritten; then
 943    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 944    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 945        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 946    fi
 947fi
 948
 949# If am was called with --rebasing (from git-rebase--am), it's up to
 950# the caller to take care of housekeeping.
 951if ! test -f "$dotest/rebasing"
 952then
 953        rm -fr "$dotest"
 954        git gc --auto
 955fi